<?php

namespace Geral\Logic\PropostaComercial;

use Faturamento\Entities\Propostaserv;
use Faturamento\Entities\Tiposerv;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Indeterminado\Entities\Opertiposerv;
use Windows\WinInt00201000\TabInt00201000004\Facade;

class ServicosPropCom 
{    
    public static function insereServicoPropostaComercial($nrservprop, $nrproposfas, $nrverpropfas, $cdtiposerv,
                                                          $nrorg, $vrhoracont = null, $qtservprop = null)
    {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        
        $dtinclusao = DateUtil::getDataAtual();
        
        try{
            $propostaserv = new Propostaserv();
            $propostaserv->setNrproposfas($nrproposfas);
            $propostaserv->setNrverpropfas($nrverpropfas);
            $propostaserv->setNrservprop($nrservprop);
            $propostaserv->setCdtiposerv($cdtiposerv);
            $propostaserv->setVrhoraprop($vrhoracont);
            $propostaserv->setQtservprop($qtservprop);
            $propostaserv->setDtinclusao($dtinclusao);
            $propostaserv->setNrorg($nrorg);

            if($qtservprop > 0) {
                $propostaserv->setVrdehoraprop($vrhoracont);
            }

            $propostaserv->persist();
            $connection->flush();

            $db->getConn()->commit();
                
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }
    
    public static function deleteServicoPropostaComercial($nrproposfas, $nrverpropfas, $cdtiposerv, $nrservprop, $nrorg)
    {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        
        try{                
             $propostaserv = Propostaserv::findOneByNrproposfasAndNrverpropfasAndCdtiposervAndNrservpropAndNrorg($nrproposfas, $nrverpropfas, $cdtiposerv, $nrservprop, $nrorg);                      
             
             if(is_object($propostaserv)) 
             {
                $propostaserv->delete();
             }
             
             $connection->flush();
             $db->getConn()->commit();
                
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }
    
    public static function insertServicoObrigProspect($servobrigRep)
    {
        $check = false;        
        foreach($servobrigRep as $servobrig)
        {
            $nrproposfas  = $servobrig['NRPROPOSFAS'];
            $nrverpropfas = $servobrig['NRVERPROPFAS'];
            $cdtiposerv   = $servobrig['CDTIPOSERV'];
            $nrorg        = $servobrig['NRORG'];                   
            $nrservprop   = $servobrig['NRSERVPROP'];
            $vrhoracont   = $servobrig['VRHORACONT'];
            $qtservprop   = $servobrig['QTSERVPROP'];

            $propostaserv = Propostaserv::findOneByNrproposfasAndNrverpropfasAndCdtiposervAndNrservpropAndNrorg($nrproposfas, $nrverpropfas, $cdtiposerv, $nrservprop, $nrorg);
        
            if(!is_object($propostaserv))
            {                         
               if($servobrig['IDSERVOBRIGPROS'] == 'S')
                {          
                   $nrservico = \Windows\WinInt00201000\TabInt00201000003\Facade::ConsultaNumeroServ(); 
                   self::insereServicoPropostaComercial($nrservico, $nrproposfas, $nrverpropfas, $cdtiposerv, $nrorg, $vrhoracont, $qtservprop);
                   $check = true;
                }                        
            }
        }

        return $check;
    }
    
    public static function insertOrUpdateServico($params)
    {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        
        $propostaserv = Propostaserv::findOneByNrproposfasAndNrverpropfasAndCdtiposervAndNrservpropAndNrorg($params['NRPROPOSFAS'], $params['NRVERPROPFAS'], $params['CDTIPOSERV'], $params['NRSERVPROP'], $params['NRORG']);
        
        try{
            if(is_object($propostaserv)) { //Atualizar
                $propostaserv->setVrhoraprop($params['VRHORAPROP']);
                $propostaserv->setQtservprop($params['QTSERVPROP']);
                $propostaserv->setVrdehoraprop($params['VRDEHORAPROP']);
                $propostaserv->setDslocalprop($params['DSLOCALPROP']);
                $propostaserv->setCdoperultatu($params['CDOPERADOR']);
                $propostaserv->setDtultatu($params['DTINCLUSAO']);
                $propostaserv->setNrorgultatu($params['NRORG']);
                $propostaserv->persist();
            } else { //Inserir
                $propostaserv = new Propostaserv();
                $propostaserv->setNrproposfas($params['NRPROPOSFAS']);
                $propostaserv->setNrverpropfas($params['NRVERPROPFAS']);
                $propostaserv->setNrservprop($params['NRSERVPROP']);
                $propostaserv->setCdtiposerv($params['CDTIPOSERV']);
                $propostaserv->setVrhoraprop($params['VRHORAPROP']);
                $propostaserv->setQtservprop($params['QTSERVPROP']);
                $propostaserv->setVrdehoraprop($params['VRDEHORAPROP']);
                $propostaserv->setDslocalprop($params['DSLOCALPROP']);
                $propostaserv->setIdtipocobrprop($params['IDTIPOCOBRPROP']);
                $propostaserv->setCdoperinclusao($params['CDOPERADOR']);
                $propostaserv->setCdoperultatu($params['CDOPERADOR']);
                $propostaserv->setDtinclusao($params['DTINCLUSAO']);
                $propostaserv->setDtultatu($params['DTINCLUSAO']);
                $propostaserv->setNrorg($params['NRORG']);
                $propostaserv->setNrorgultatu($params['NRORG']);
                $propostaserv->setNrorginclusao($params['NRORG']);
                $propostaserv->persist();
            }
            
            $connection->flush();
            $db->getConn()->commit();                
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }
    
    public static function retornaIdObrigServico($cdTipoServ, $nrOrg)
    {
        $tipoServ = Tiposerv::findOneByCdtiposervAndNrorg($cdTipoServ, $nrOrg);
        
        if(is_object($tipoServ)) {
            return $tipoServ->getIdservobrigpros();
        }
        return;
    }

    public static function atualizarParcelas($nrProposta, $nrVersao, $vrTotal)
    {
        if($vrTotal == 0) {
            NegociarServicos::deleteParcelas($nrProposta, $nrVersao, Ambiente::getNrorg());
        } else {
            $parcelasServico = Propostaserv::getRepository()->consultaParcelasNegociarServicos($nrProposta, $nrVersao);
            $paramParcela    = array('VRTOTALSERV' => $vrTotal);

            if(count($parcelasServico) > 0) {
                $dtVencServ = DateUtil::getDataDeString($parcelasServico[0]['DTVENCSERVPROP'], DateUtil::FORMATO_BRASILEIRO_DATAHORA);

                $paramParcela['QTDPARCELA']     = count($parcelasServico);
                $paramParcela['DTVENCSERVPROP'] = $dtVencServ;
            } else {
                $paramParcela['QTDPARCELA']     = 1;
                $paramParcela['DTVENCSERVPROP'] = DateUtil::adicionaIntervalo(DateUtil::getDataAtual(), 15, DateUtil::DIA);
            }

            Facade::processGeraParcelasOnClick($paramParcela);
        }
    }

    public static function getVrDescontoMaxOper($cdTipoServ, $cdOperador)
    {
        $operTipoServ = Opertiposerv::findOneByCdtiposervAndCdoperador($cdTipoServ, $cdOperador);

        if(is_object($operTipoServ)) {
            return $operTipoServ->getVrpedesoperserv();
        }

        return 0;
    }

    public static function validaQtHorasServicos($nrProposta, $nrVersao)
    {
        $servicos = Propostaserv::findByNrproposfasAndNrverpropfas($nrProposta, $nrVersao);

        $qthoras = false;

        foreach ($servicos as $servico) {
            if($servico->getQtservprop()) {
                $qthoras = true;
            }
        }

        return $qthoras;
    }

    public static function getPermissaoExcluirServ($nrProspota, $nrVersao, $cdTipoServ)
    {
        $prospotaServ = Propostaserv::findByNrproposfasAndNrverpropfasAndCdtiposerv($nrProspota, $nrVersao, $cdTipoServ);
        $count = count($prospotaServ);

        if($count > 1) {
            return array('COUNT_SERV' => $count,
                         'PERMISSAO'  => true);
        }

        return array('COUNT_SERV' => $count,
                     'PERMISSAO'  => false);
    }
}