<?php
namespace Geral\Util;

use \Geral\Util\Novocodigo;
use \Geral\Util\Ambiente;
/**
 * Created by JetBrains PhpStorm.
 * User: marcellichtnow
 * Date: 14/03/13
 * Time: 08:17
 * To change this template use File | Settings | File Templates.
 */
class Lista
{
    private $separador;
    private $chaves;

    /**
     * string de multisearch
     * $chaves vai ser igual o nome do(s) campo(s) chave do array.
     * ex: array[chave=?? valor=??]
     *     array[2]
     *     cdfilial=9999
     *     cdserv=0001
     *
     * os campos a serem passados para $chaves=[cdfilial,cdserv]
     *
     * $separador vai ser a string que vai separar a lista.
     * ex: $separador = "_"
     *
     * @param array $chaves
     * @param $separador
     */
    public function __construct($chaves = array(), $separador)
    {
        $this->chaves    = $chaves;
        $this->separador = $separador;
    }

    /**
     * gera lista de string passando um array de string
     * ex: array[3]
     *     array[2] cdfilial=9999 , cdserv=0001
     *     array[2] cdfilial=9999 , cdserv=0002
     *     array[2] cdfilial=9901 , cdserv=002
     * metodo vai retornar $stlista = 99990001_99990002_9901002
     *                  ou $stlista = 0001_0002_002
     *dependendo de quantas chaves serao passadas.
     *
     * @param $params
     * @return string
     */
    public function getListaString($params)
    {
        $stlista = "";

        foreach ($params as $linha) {
            foreach ($this->chaves as $chave) {
                $stlista .= $linha[$chave];
            }

            $stlista .= $this->separador;
        }

        // Removendo o separador do ultimo caractere.
        $stlista = substr($stlista, 0, -1);

        return $stlista;
    }


    /**
     * esse metodo cria uma lista na Tabela Lista
     * recebe a lista do metodo getListaString e gera uma linha no banco pra cada string
     * ex: stlista = 0001_0002_0003_0004
     *     banco = 0000000001|0001|
     * novocodigo->0000000001|0002|<-string
     *             0000000001|0003|
     *             0000000001|0004|
     * retorna o codigo da lista
     */
    public function getListaBanco($params){
        $listaString = $this->getListaString($params);
        $listaArray = explode($this->separador, $listaString);

        $nrlista = Novocodigo::geraCodigo(Ambiente::getNrorg(), 'LISTA');

        foreach ($listaArray as $lista) {
            $entidade = new \Geral\Entities\Lista();
            $entidade->setCdlista($lista);
            $entidade->setNrlista($nrlista);
            $entidade->setNrorg(\Geral\Util\Ambiente::getNrorg());
            $entidade->persist();
        }

        return $nrlista;
    }

    /**
     * esse metodo deleta a lista criada na Tabela Lista
     * recebe o codigo da lista deletando todos os campos que tiverem o codigo.
     *
     * nao retorna nada
     */
    public function deletaListaBanco($nrlista){

        $conn = \Setforms2\Shared\Connection::getInstance();
        $SQL =  "DELETE FROM LISTA WHERE NRLISTA= :NRLISTA";
        $conn->execute($SQL, $params = array("NRLISTA" => $nrlista));

    }

}
