var Est43000_ManutencaoDoUltimoCusto_Controller = function(templateManager, ScreenService, General, ZhFilterPreferences){
    
    var mensagens = {
        custoAtualizado: 'Atualização do ultimo custo realizada com sucessso.',
        custoImportado: 'Custo importado com sucesso.',
        oriDestIgual: 'Destino deve ser diferente da origem.',
        controlaEstoque: 'Unidade selecionada não controla estoque.',
        controlaAlmoxarifado: 'Unidade selecionada não controla almoxarifado.',
        prodFinInvalido: 'Confirmar atualização do último custo de compra?',
        dataErro: 'A data de compra deve ser menor do que a data de processamento.',
        erroAdicionar: 'Selecione uma filial antes de adicionar.',
        confirmaImportacao: 'A importação dos custos irá substituir o último custo' +
        ' dos produtos da filial de destino. Confirma operação?',
        confirmaAtualizacao: 'Confirmar atualização do último custo de compra?',
        errorFin: 'Índice financeiro parametrizado na personalização do si' +
        'stema não possui valor cadastrado para uma data do período.'
    };
    
    this.setNameLayout = function(args){
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
    
      this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
    
    
    this.preparaFiltroEFields = function(widget){
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            rowsToSet.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            ZhFilterPreferences.setOriginalFilter(widget.id, rowsToSet);
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function() {
                let filtro = templateManager.container.getActiveWidget();
                this.validaFilial(filtro);
            }.bind(this));
        }.bind(this));
    };
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
    
    this.validaFilial = function(widget, fieldName) {
        var cdfilial =  widget.currentRow.CDFILIAL;
        if(cdfilial) {
            var filter = [
                {
                    "name":"CDFILIAL",
                    "operator":"=",
                    "value": cdfilial
                }
            ];
            
            General.callRestEngine('est_ajuste#/crud/paramfilial', 'FilterData', filter).then(function(success){
                widget.currentRow.DTPROCESSA = success.dataset.paramfilial[0].DTPROCESSA;
                widget.currentRow.controlaLote = success.dataset.paramfilial[0].IDUTILLOTE;
                let controlaAlmox = success.dataset.paramfilial[0].IDUTILALMOX;
                if(success.dataset.paramfilial[0].IDCTRLESTQ === 'S') {
                    if(success.dataset.paramfilial[0].IDUTILALMOX === 'S') {
                        if(fieldName === 'NMFILIALDEST') {
                            widget.getField('DSALMOXARIFEDEST').readOnly = false;
                            if(success.dataset.paramfilial[0].IDUTILLCESTQ == 'S') {
                                widget.currentRow.controlaLocalDest = true;
                            }
                            else {
                                widget.currentRow.controlaLocalDest = false;
                            }
                        }
                        else {
                            widget.getField('DSALMOXARIFE').readOnly = false;
                            if(success.dataset.paramfilial[0].IDUTILLCESTQ == 'S') {
                                widget.currentRow.controlaLocal = true;
                            }
                            else {
                                widget.currentRow.controlaLocal = false;
                            }
                        }
                        widget.getField('DSALMOXARIFE').dataSourceFilter.forEach(function(fil){
                            if(fil.name == "CDFILIAL"){
                                fil.value = widget.currentRow.CDFILIAL;
                            }
                        });
                        widget.getField('DSALMOXARIFE').reload();
                    }
                    else {
                        let fieldAlmoxarido = widget.getField('DSALMOXARIFE');
                       
                        if(controlaAlmox === 'N') {
                            widget.getField('DSALMOXARIFEDEST').readOnly = true;
                            widget.getField('DSLOCALESTOQDEST').readOnly = true;
                            delete fieldAlmoxarido.validations;
                        }
                        else {
                            ScreenService.showMessage(mensagens.controlaAlmoxarifado);
                            widget.getField('DSALMOXARIFE').readOnly = true;
                            widget.getField('DSLOCALESTOQ').readOnly = true;
                            fieldAlmoxarido.validations = {"required": {"message": "Campo Obrigatório!"}};
                        }
                    }
                }
                else {
                    if(fieldName === 'NMFILIALDEST') {
                        widget.currentRow.CDFILIALDEST = '';
                        widget.currentRow.NMFILIALDEST = '';
                        ScreenService.showMessage(mensagens.controlaEstoque);
                        widget.currentRow.controlaLocalDest = false;
                    }
                    else {
                        widget.currentRow.CDFILIAL = '';
                        widget.currentRow.NMFILIAL = '';
                        widget.currentRow.controlaLocal = false;
                    }
                }
            });
        }
        else {
            widget.getField('DSALMOXARIFE').readOnly = true;
            widget.getField('DSLOCALESTOQ').readOnly = true;
        }
        widget.currentRow.CDALMOXARIFE = '';
        widget.currentRow.DSALMOXARIFE = '';
        widget.currentRow.CDLOCALESTOQ = '';
        widget.currentRow.DSLOCALESTOQ = '';
	};
	
	this.setReadOnlyLocal = function(widget, fieldName) {
	    if(widget.currentRow.DSALMOXARIFE) {
	        if(fieldName === 'DSALMOXARIFEDEST') {
	            if(widget.currentRow.controlaLocal) {
	                widget.getField('DSLOCALESTOQDEST').readOnly = false;
	            }
	        }
	        else  {
	            if(widget.currentRow.controlaLocal) {
	                widget.getField('DSLOCALESTOQ').readOnly = false;
	            }
	        } 
	        widget.getField('DSLOCALESTOQ').dataSourceFilter.forEach(function(fil){
	            switch (fil.name){
	                case 'CDFILIAL':
	                    fil.value = widget.currentRow.CDFILIAL;
	                break;
	                
	                case 'CDALMOXARIFE':
	                    fil.value = widget.currentRow.CDALMOXARIFE;
	                break;
	            }
	        });
	    }  
	    else {
	    	if(fieldName === 'DSALMOXARIFEDEST') {
    	        if(widget.currentRow.controlaLocal) {
	    		    widget.getField('DSLOCALESTOQDEST').readOnly = true;
	            }
		        widget.currentRow.CDLOCALESTOQDEST = '';
	            widget.currentRow.DSLOCALESTOQDEST = '';
	    	}
	    	else {
		        if(widget.currentRow.controlaLocal) {
	                widget.getField('DSLOCALESTOQ').readOnly = false;
	            }
		        widget.currentRow.CDLOCALESTOQ = '';
	            widget.currentRow.DSLOCALESTOQ = '';
	    	}
	    }
	};
	
	this.FilterProdIni = function(args){
		var widget = args.owner.field.widget;
        var row = widget.currentRow;
        var prodIniIsSet = this.fieldIsSet(row.P_CDPRODINI);
        if(!prodIniIsSet) {
    		widget.currentRow.NMPRODFIN = '';
   
        }
        widget.getField('NMPRODFIN').readOnly = !prodIniIsSet;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !prodIniIsSet;
    };
    
    this.FilterProdFin = function(args){
    	var widget = args.owner.field.widget;
        var row = widget.currentRow;
        var prodFinIsSet = this.fieldIsSet(row.P_CDPRODFIN);
		if(prodFinIsSet) {
            if(row.P_CDPRODINI > row.P_PRODFIN){
                ScreenService.showMessage(mensagens.prodFinInvalido);
                return 0;
            }
        } 
        widget.reload();
    };
    
    this.fieldIsSet = function(fieldValue) {
        if(fieldValue) return true;
        else return false;
    };
	
	this.openPopup = function(widgetName) {
        var widgetPopup = templateManager.container.getWidget(widgetName);
        widgetPopup.isVisible = true;
        widgetPopup.activate();
        widgetPopup.edit();
        ScreenService.openPopup(widgetPopup);
    };
    
    this.saveNewManutencao = function(widget) {
        if(widget.isValid()) {
            if(!widget.currentRow.NRLOTEESTQ || widget.currentRow.NRLOTEESTQ === ' ') {
                widget.currentRow.NRLOTEESTQ = ' ';
                widget.currentRow.NRSUBLOTE  = ' ';
            }
            
            General.callRestEngine('est_ajuste#/saveManutencao', 'Row', widget.currentRow).then(function(success){
                    if(widget.currentRow.__is_new) {
                        ScreenService.goBack();
                        widget.reload();
                    }
                    else {
                        ScreenService.closePopup();
                        widget.view();
                        widget.reload();
                    }
                }.bind(this),
                function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        }
    };
    
    this.validaData = function(widget) {
        if(widget.currentRow.DTPROCESSA) {
            if(widget.currentRow.DTPROCESSA < widget.currentRow.DTCUSTCMPPRO) {
                ScreenService.showMessage(mensagens.dataErro);
            }
        }
    };
    
    this.adicionar = function(widget) {
        var rowFilter = widget.appliedFilter.FILTER_ROW;
        if(rowFilter.CDFILIAL) {
            widget.newRow();
            var Data = new Date();
            var dataDia;
            var dataMonth;
            if(Data.getDate() < 10) dataDia = '0'+Data.getDate();
            else dataDia = Data.getDate();
            if(Data.getMonth() < 10) dataMonth = '0'+(Data.getMonth()+1);
            else dataMonth = Data.getMonth();
            var dataAtual = dataDia+'/'+dataMonth+'/'+Data.getFullYear();
            widget.currentRow.DTCUSTCMPPRO = dataAtual;
            widget.currentRow.CDFILIAL = rowFilter.CDFILIAL;
            widget.currentRow.CDALMOXARIFE = rowFilter.CDALMOXARIFE || ' ';
            widget.currentRow.CDLOCALESTOQ = rowFilter.CDLOCALESTOQ || ' ';
            widget.currentRow.DTPROCESSA   = rowFilter.DTPROCESSA;
        }  
        else {
            ScreenService.showMessage(mensagens.erroAdicionar);
        }
    };
    
    this.controlaLoteProduto = function(widget) {
        if(widget.currentRow.NMPRODUTO) {
            if(widget.appliedFilter.FILTER_ROW.controlaLote) {
                widget.currentRow.NRLOTEESTQ = ' ';
                widget.getField('NRLOTEESTQ').reload();
                widget.getField('NRLOTEESTQ').readOnly = false;
            }
            else {
                widget.currentRow.NRLOTEESTQ = ' ';
                widget.getField('NRLOTEESTQ').reload();
                widget.getField('NRLOTEESTQ').readOnly = true;
            }
        }
        else {
            widget.currentRow.NRLOTEESTQ = ' ';
            widget.getField('NRLOTEESTQ').reload();
            widget.currentRow.NRLOTEESTQ.readOnly = true;
        }
    };
    
    this.saveImportacao = function(widget) {
        if(widget.isValid()) {
            var row = widget.currentRow;
            row.CDNVPRODUTO = General.getLevelByMask('CDPICTPROD',1).length;
            if(row.CDFILIALDEST == row.CDFILIAL && row.CDALMOXARIFE == row.CDALMOXARIFEDEST && row.CDLOCALESTOQDEST == row.CDLOCALESTOQDEST){
                ScreenService.showMessage(mensagens.oriDestIgual);
            }
            else {
                ScreenService.confirmMessage(ScreenService.i18n(mensagens.confirmaImportacao), 'question', function (success) {
                    General.callRestEngine('est_ajuste#/importaUltimoCusto', 'Row', row).then(function(success){
                        var widgetActivate = templateManager.container.getWidget('widgetProduto');
                        var widgetPopup = templateManager.container.getWidget('IMPORTACUSTO');
                        ScreenService.goBack();
                        widgetPopup.isVisible = false;
                        widgetPopup.currentRow = {};
                        ScreenService.closePopup(widgetPopup);
                        ScreenService.showMessage(mensagens.custoImportado);
                        widgetActivate.activate();
                        widgetActivate.reload();
                        ScreenService.closePopup();
                    },
                    function(callback){
                            if(callback.data){
                                ScreenService.showMessage(callback.data.error);
                            }
                        }
                    );
                }.bind(this));
            }
        }
    };
    
    this.atualizaUltimoCusto = function(widget) {
        if(widget.isValid()) {
            ScreenService.confirmMessage(ScreenService.i18n(mensagens.confirmaAtualizacao), 'question', function (success) {
                var row = widget.currentRow;
                row.CDNVPRODUTO = General.getLevelByMask('CDPICTPROD',1).length;
                    General.callRestEngine('est_ajuste#/atualizaUltimoCusto', 'Row', row).then(function(success){
                        var widgetActivate = templateManager.container.getWidget('widgetProduto');
                        var widgetPopup = templateManager.container.getWidget('ATUALIZACUSTO');
                        widgetPopup.isVisible = false;
                        widgetPopup.currentRow = {};
                        ScreenService.closePopup(widgetPopup);
                        ScreenService.showMessage(mensagens.custoAtualizado);
                        widgetActivate.activate();
                        widgetActivate.reload();
                        ScreenService.closePopup();
        
                    },
                    function(callback){
                            if(callback.data){
                                ScreenService.showMessage(mensagens.errorFin);
                            }
                        }
                    );
            }.bind(this));
        }
    };

    this.closePopup = function(widgetName, popupName) {
        var widget = templateManager.container.getWidget(popupName);
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget(widgetName);
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widgetActivate.activate();
        widgetActivate.reload();
    };	
    
    this.changeFilter = function(widget, preference){
        var filterRow = preference.FILTER_ROW;
        filterRow.P_CDPRODFIN = filterRow.P_CDPRODFIN + "zzzzzzzzzzzzzzzzzzz";
        filterRow.P_CDPRODFIN = filterRow.P_CDPRODFIN.substring(0, 20);
        var filtro= [
            {
                "name":"CDFILIAL",
                "operator":"=",
                "value": filterRow.CDFILIAL ? filterRow.CDFILIAL : null
            },
            {
                "name":"DTREFERENCIA",
                "operator":"=",
                "value": filterRow.DTREFERENCIA ? filterRow.DTREFERENCIA : null
            },
            {
                "name":"CDALMOXARIFE",
                "operator":"=",
                "value": filterRow.CDALMOXARIFE ? filterRow.CDALMOXARIFE : null
            },
            {
                "name":"CDLOCALESTOQ",
                "operator":"=",
                "value": filterRow.CDLOCALESTOQ ? filterRow.CDLOCALESTOQ : null
            },
            {
                "name":"P_CDPRODINI",
                "operator":"=",
                "value": filterRow.P_CDPRODINI ? filterRow.P_CDPRODINI : null
            },
            {
                "name":"P_CDPRODFIN",
                "operator":"=",
                "value": filterRow.P_CDPRODFIN ? filterRow.P_CDPRODFIN : null
            }
        ];
        
        widget.dataSourceFilter = filtro;
        widget.reload();
        
    };


};
Configuration(function (ContextRegister){
    ContextRegister.register('Est43000_ManutencaoDoUltimoCusto_Controller', Est43000_ManutencaoDoUltimoCusto_Controller);
});
